package com.example.ellegadodepintia.exploradoresDePintia

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.TextView
import androidx.fragment.app.DialogFragment
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.objeto.Objeto

class ModalConfirmacion : DialogFragment() {
    var objeto: Objeto? = null
    var coste: Int? = null
    var onDismissListener: ((isMejora: Boolean) -> Unit)? = null

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        return inflater.inflate(R.layout.modal_confirmacion, container, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        val nivelActual = GameState.jugador.nivelCiudad
        val costeNuevoNivel = 50 * nivelActual
        val monedasJugador = GameState.jugador.monedas

        val textoInformacion = view.findViewById<TextView>(R.id.textoInformacion)
        ("Vas a mejorar la taberna por el coste de $costeNuevoNivel monedas. ¿Estás seguro?").also { textoInformacion.text = it }

        val botonMejorar = view.findViewById<Button>(R.id.botonMejorar)
        botonMejorar.setOnClickListener{
            if (monedasJugador >= costeNuevoNivel){
                val nObjetos = (nivelActual + 1) * 2
                GameState.jugador.actualizarObjetosTienda(nObjetos)
                GameState.jugador.actualizarObjetosArmeria(nObjetos)
                GameState.jugador.actualizarNivelCiudad(nivelActual + 1)
                GameState.jugador.actualizarMonedas(monedasJugador - costeNuevoNivel)
                onDismissListener?.invoke(true)
                dismiss()
            } else {
                onDismissListener?.invoke(false)
                dismiss()
            }

        }

        val botonCancelar = view.findViewById<Button>(R.id.botonCancelar)
        botonCancelar.setOnClickListener{
            onDismissListener?.invoke(false)
            dismiss()
        }
    }
}
